<template>
  <header :class="['base-header', { 'base-header--menu-open': isShowMenu }]">
    <div class="base-header__wrap">
      <div class="base-header__container container">
        <nuxt-link :to="localePath('/')" class="logo-link">
          <span class="visually-hidden">home page</span>
          <icon-logo class="logo" />
        </nuxt-link>
        <div class="base-header__nav">
          <nav>
            <nuxt-link
              :to="localePath('/')"
              class="base-header__nav-link"
              @click.native="closeMenu"
              >{{ $t('Token') }}</nuxt-link
            >
            <nuxt-link
              class="base-header__nav-link"
              :to="localePath('/app')"
              @click.native="closeMenu"
              >{{ $t('App') }}</nuxt-link
            >
            <div class='dropdown-link-wrap'>
              <nuxt-link
                :to="localePath('/hub')"
                class="base-header__nav-link dropdown-link"
                @click.native="closeMenu"
              >{{ $t('Hub') }}
                <svg width="7" height="5" viewBox="0 0 7 5" fill="none" xmlns="http://www.w3.org/2000/svg">
                  <path d="M0.5 0.5L3.5 3.5L6.5 0.5" stroke="currentColor"/>
                </svg>
              </nuxt-link
              >
              <div class='dropdown-content'>
                <nuxt-link
                  :to="localePath('/cloud')"
                  class="base-header__nav-link"
                  @click.native="closeMenu"
                >Cloud</nuxt-link
                >
<!--                <nuxt-link
                  :to="localePath('/otc')"
                  class="base-header__nav-link"
                  @click.native="closeMenu"
                >Otc</nuxt-link
                >-->
              </div>
            </div>
            <a
              class="base-header__nav-link"
              href="https://www.tbcc.com/trade/TBCC_USDT"
              target="_blank"
              @click="closeMenu"
              >{{ $t('Exchange') }}</a
            >
          </nav>
          <div class="actions">
            <base-language-selection
              :id="'language'"
              :label="'select language'"
              class="actions__language"
              :list="languages"
              item-key="language"
              :default-value="defaultLocale[0]"
              @selected="(value) => selectLanguage(value)"
            />
          </div>
        </div>
        <menu-button
          class="base-header__menu-button"
          :active="isShowMenu"
          @click.native="toggleShowMenu"
        />
      </div>
    </div>
  </header>
</template>

<script>
import { mapActions } from 'vuex'
import IconLogo from '../icon/IconLogo'
import MenuButton from '../index/MenuButton'
import BaseLanguageSelection from './BaseLanguageSelection'

export default {
  components: { MenuButton, BaseLanguageSelection, IconLogo },
  data() {
    return {
      languages: [
        { language: 'En', id: 1, value: 'en' },
        { language: 'Ch', id: 2, value: 'ch' },
        { language: 'Tur', id: 3, value: 'tur' },
      ],
      currentLanguage: '',
      isShowMenu: false,
    }
  },

  computed: {
    currentLocale() {
      return this.$i18n.localeProperties.code
    },

    defaultLocale() {
      return this.languages.filter((item) => item.value === this.currentLocale)
    },
  },

  watch: {
    isShowMenu() {
      if (this.isShowMenu && window.innerWidth < 1024) {
        document.body.style.overflow = 'hidden'
      } else {
        document.body.style.overflow = 'visible'
      }
    },
  },

  mounted() {
    this.currentLanguage = this.currentLocale
    window.addEventListener('scroll', this.scrollHeader)
  },

  destroy() {
    window.removeEventListener('scroll', this.scrollHeader)
  },

  methods: {
    ...mapActions({
      toggleSignInForm: 'toggleShowSignInForm',
    }),

    scrollHeader() {
      const header = document.querySelector('.base-header')
      const headerWrap = document.querySelector('.base-header__wrap')
      if (window.scrollY >= 575) {
        headerWrap.classList.add('base-header__wrap--scroll-575')
      }
      if (window.scrollY <= 575) {
        headerWrap.classList.remove('base-header__wrap--scroll-575')
      }
      if (window.scrollY >= 100) {
        header.classList.add('base-header--scroll')
        headerWrap.classList.add('base-header__wrap--scroll')
      } else {
        header.classList.remove('base-header--scroll')
        headerWrap.classList.remove('base-header__wrap--scroll')
      }
    },

    selectLanguage(value) {
      this.$i18n.setLocale(value.value)
    },

    toggleShowMenu() {
      this.isShowMenu = !this.isShowMenu
    },

    closeMenu() {
      this.isShowMenu = false
    },
  },
}
</script>

<i18n>
{
  "en": {
    "Token": "Token",
    "App": "App",
    "Hub": "Hub",
    "Exchange": "Exchange"
  },
  "ch": {
    "Token": "代币",
    "App": "应用",
    "Hub": "枢纽",
    "Exchange": "交易"
  },
  "tur": {
    "Token": "Token",
    "App": "App",
    "Hub": "Hub",
    "Exchange": "Exchange"
  }
}
</i18n>

<style lang="scss" scoped>
nav {
  margin: 0 auto;
  display: flex;

  @media (max-width: 1023px) {
    display: flex;
    flex-direction: column;
    margin: 0;
    overflow-y: auto;
  }
}

.base-header {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  z-index: 3;

  @media (min-width: 1024px) {
    top: 40px;
  }

  &__container {
    display: flex;
    align-items: center;
    padding: 16px 26px;
    max-width: 1440px;
    position: relative;

    @media (min-width: 768px) {
      padding: 16px 30px;
    }

    @media (min-width: 1200px) {
      padding: 16px 40px;
    }
  }

  &__nav {
    width: 100%;
    display: flex;

    @media (max-width: 1023px) {
      position: absolute;
      left: 0;
      right: 0;
      justify-content: space-between;
      bottom: calc(65px - 100vh);
      background: linear-gradient(90deg, rgba(7, 20, 40, 0.9) 0, #041344 100%);
      padding: 15px 26px 20px;
      height: calc(100vh - 65px);
      opacity: 0;
      transform: translateX(200%);
      transition: transform 1s;
    }

    @media (min-width: 1024px) {
      display: flex;
      align-items: center;
    }
  }

  &__nav-link {
    font-weight: 400;
    font-size: 16px;
    line-height: 16px;
    color: #ffffff;
    transition: color 0.5s;

    &:hover {
      color: #66b6ff;
    }

    &:not(:last-child) {
      margin-right: 60px;
    }

    @media (max-width: 1023px) {
      font-weight: 600;
      font-size: 26px;
      line-height: 125%;
      padding: 20px 4px;
    }
  }

  &__menu-button {
    margin-left: auto;
    @media (min-width: 1024px) {
      display: none;
    }
  }

  &--scroll {
    top: 0;
  }

  &__wrap {
    &--scroll {
      top: 0;

      background: linear-gradient(161.68deg, #1f0c71 27.28%, #041344 67.8%);
    }

    &--scroll-575 {
      top: 0;

      background: #051345;

      .dropdown-content {
        background: #051345 !important;
      }
    }
  }


  &--menu-open {
    @media (max-width: 1023px) {
      transition: background-color 1s;
      background: #041344;

      .base-header__nav {
        opacity: 1;
        transform: translateX(0);
      }
    }
  }
}

.logo-link {
  &::before {
    display: none;
  }
}

.logo {
  width: 80px;
  height: 33px;

  @media (min-width: 1024px) {
    margin-right: 70px;
    width: 95px;
    height: 38px;
  }
}

.actions {
  display: flex;
  align-items: center;

  @media (max-width: 1023px) {
    justify-content: flex-end;
    margin: 10px 0 20px;
    align-items: flex-start;
  }

  &__language {
    margin-right: 25px;

    @media (min-width: 1024px) {
      margin-left: 95px;
    }
  }

  &__sign-in {
    padding: 12px 30px;
    border: 2px solid #ffffff;
    border-radius: 20px;
    color: white;
    background: transparent !important;

    &:hover {
      background: transparent !important;
    }
  }
}

.nuxt-link-exact-active {
  color: #66b6ff;
  position: relative;

  @media (min-width: 1024px) {
    &::before {
      content: '';
      position: absolute;
      width: 12px;
      height: 2px;
      background-color: #66b6ff;
      bottom: -8px;
      left: 0;
    }
  }
}

@media (min-width: 1024px) {
  .dropdown-link {
    position: relative;
    cursor: pointer;
    padding-right: 20px;
    padding-top: 7px;
    padding-bottom: 7px;

    svg {
      position: absolute;
      top: 50%;
      transform: translateY(-50%);
      right: 2px;
    }
  }

  .dropdown-content {
    position: absolute;
    padding: 12px 10px 6px;
    border-radius: 10px;
    border: 1px solid white;
    left: -29px;
    bottom: -56px;
    width: 100%;
    background: #1F0C71;
    opacity: 0;
    transition: opacity 0.3s;
    pointer-events: none;


    a:first-child {
      margin-bottom: 10px;
      display: inline-block;
    }

    a {
      &:before {
        display: none;
      }
    }

    &:hover {
      opacity: 1;
      pointer-events: unset;
    }
  }

  .dropdown-link-wrap {
    position: relative;

    @media (max-width: 1023px) {
      padding: 20px 0;
    }

    &:hover {
      .dropdown-content {
        opacity: 1;
        pointer-events: unset;
      }
    }

  }
}

@media (max-width: 1023px) {
  .dropdown-link {
    display: inline-block;

    svg {
      display: none;
    }
  }

  .dropdown-content {
    display: flex;
    flex-direction: column;
  }

}

</style>
